VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsApplication"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private WithEvents mf_Parent As mdiManager
Attribute mf_Parent.VB_VarHelpID = -1
Private WithEvents mo_Projects As clsProjects
Attribute mo_Projects.VB_VarHelpID = -1
Private WithEvents mo_Tasks As clsTasks
Attribute mo_Tasks.VB_VarHelpID = -1
Private WithEvents mo_Today As clsToday
Attribute mo_Today.VB_VarHelpID = -1
Private WithEvents mo_Archive As clsArchive
Attribute mo_Archive.VB_VarHelpID = -1
Private mo_Contacts As clsContacts
Private mo_DataService As clsDataService
Private mo_Reports As clsReports
Private mo_ProgConfig As clsProgConfig
Private mo_PickList As clsPickList
Private mc_Tasks As New Collection '---collection of clsTasks objects
Private mc_Projects As New Collection '---collection of clsProjects objects
Private mc_Sources As New Collection '---collection of clsSource objects
Private mo_User As clsUser
Private mo_Source As clsSource
Private Sub CreateContacts()

   If (mo_Contacts Is Nothing) Then
      Set mo_Contacts = New clsContacts
      mo_Contacts.Init mo_DataService
   End If
   mo_Contacts.Show
   
End Sub




Private Sub CreateToday()
   
   '---test state of Appointment object
   If (mo_Today Is Nothing) Then
      Set mo_Today = New clsToday
      mo_Today.Init mo_DataService, mo_ProgConfig, mo_PickList
   End If
   
   '---show appointments
   mo_Today.Show

End Sub

Private Sub CreateProjects()

   '---test state of Project object
   If mo_User.Manager Then
      If (mo_Projects Is Nothing) Then '---init
         Set mo_Projects = New clsProjects
         mo_Projects.Init mo_DataService, mo_ProgConfig, mo_PickList, mo_User.User
      End If
      '---show projects
      mo_Projects.Show
   Else
      MsgBox "You don't have permission to view projects.", vbInformation
   End If

End Sub




Private Sub CreateTasks()
      
   '---test state of Task object
   If (mo_Tasks Is Nothing) Then
      Set mo_Tasks = New clsTasks
      mo_Tasks.Init mo_DataService, mo_ProgConfig, mo_PickList
   End If
   
   '---show tasks
   mo_Tasks.Show

End Sub



Private Sub LoadArchive()
   
   If (mo_Archive Is Nothing) Then
      Set mo_Archive = New clsArchive
      mo_Archive.Init mo_DataService, mo_ProgConfig, mo_PickList
   End If
   
   mo_Archive.Show
   
End Sub


Private Sub LoadAgent()
   
   Load frmAgent
   Set frmAgent.Appts = mo_Today.ApptDP
   Set frmAgent.MngTasks = mo_Today.MngTasks
   frmAgent.Show
   frmAgent.ZOrder 0

End Sub


Private Sub LoadSourceEditor()

  If (mo_Source Is Nothing) Then
      Set mo_Source = New clsSource
      mo_Source.Init mo_PickList, mo_DataService, mo_ProgConfig
  End If

   mo_Source.Show SHOW_SOURCES

End Sub

Public Sub RemoveProjectMember(sKey As String)

   On Error Resume Next
   mc_Projects.Remove (sKey)
   

End Sub

Public Sub RemoveSourceMember(sKey As String)

   On Error Resume Next
   mc_Sources.Remove sKey

End Sub

Public Sub RemoveTaskMember(sKey As String)

   '---this is called from a clsTask object when it is part of the mc_Tasks collection _
   in order to free up some memory.
   
   On Error Resume Next
   mc_Tasks.Remove sKey

End Sub

Public Sub StartApplication()
         
   Dim fLogin As New frmLogin
   Dim bOK As Boolean
   
    fLogin.Display
    bOK = fLogin.OK
    If bOK Then
      Set mo_User = fLogin.UserProfile
      Set mo_DataService = fLogin.DataService
      Unload fLogin
       '---init module objects
      SetHourglass
      Set mf_Parent = New mdiManager
      Set mo_ProgConfig = New clsProgConfig
      Set mo_PickList = New clsPickList
      mo_PickList.Init mo_DataService
      '---show parent form
      mf_Parent.Show
      mf_Parent.WindowState = 0
      CreateToday
      '---create project list
      mo_DataService.LoadProjects mf_Parent.lstProjects
      '---create resource list
      mo_PickList.LoadPickList mf_Parent.lstTask, PIC_RESOURCE
      '---create source list
      mo_PickList.LoadPickList mf_Parent.lstSources, PIC_SOURCE
      SetReady
   Else
      Unload fLogin
      EndApplication
   End If
   

End Sub

Private Sub EndApplication()

   ProgNote "Check for open, unsaved forms"
   '---destroy all objects
   On Error GoTo TRAP
   Set mo_Projects = Nothing
   Set mo_Tasks = Nothing
   Set mo_DataService = Nothing
   Unload mf_Parent
   Set mf_Parent = Nothing
   '---note that "END" isn't needed here becasue once mf_Parent is destroyed, this object has no life

   Exit Sub
   
TRAP:
   ProgNote "Err in EndApplication: " & Err.Description
   Resume Next
   
End Sub


Public Sub UpdateProgram(tUpdateType As UPD_TYPE)
   
   '---this is fired FROM the child object that made the update TO the other _
   child objects that need to be updated
   
   Dim oTasks As clsTasks
   Dim oProject As clsProjects
   Dim oSource As clsSource
   
   Select Case tUpdateType
      Case UPD_TODAY_TASK '---update from Today Action
         '---update tasks object
         If Not (mo_Tasks Is Nothing) Then mo_Tasks.Refresh
         '---update archive
         If Not (mo_Archive Is Nothing) Then mo_Archive.Refresh
      Case UPD_TASKS_TASK '---update from Tasks
         '---update Today list
         If Not (mo_Today Is Nothing) Then mo_Today.Refresh
         '---update archive
         If Not (mo_Archive Is Nothing) Then mo_Archive.Refresh
      Case UPD_PROJECT_TASK '---task update for one project
         '---update tasks object
         If Not (mo_Tasks Is Nothing) Then mo_Tasks.Refresh
         '---update Today list
         If Not (mo_Today Is Nothing) Then mo_Today.Refresh
         '---update archive
         If Not (mo_Archive Is Nothing) Then mo_Archive.Refresh
      Case UPD_PROJECT_ADD_DEL '---update all pick lists for project change (added project or deleted project)
          '---update today
          If Not (mo_Today Is Nothing) Then mo_Today.Refresh
          '---update tasks object
          If Not (mo_Tasks Is Nothing) Then mo_Tasks.Refresh
         '---update archive
         If Not (mo_Archive Is Nothing) Then mo_Archive.Refresh
          '---update parent quick view project list
          mf_Parent.lstProjects.Clear
          mo_Projects.LoadQuickView mf_Parent.lstProjects
      Case UPD_ASSIGNED '---individually displayed task list have generated a change
         '---update tasks object
         If Not (mo_Tasks Is Nothing) Then mo_Tasks.Refresh
         '---update Today list
         If Not (mo_Today Is Nothing) Then mo_Today.Refresh
         '---update archive
         If Not (mo_Archive Is Nothing) Then mo_Archive.Refresh
      Case UPD_PROJECT_MOD '---a project's data (not tasks) have been modifed so update the master project list
         If Not (mo_Projects Is Nothing) Then mo_Projects.RefreshProjects
      Case UPD_UNARCHIVE
         If Not (mo_Tasks Is Nothing) Then mo_Tasks.Refresh
         If Not (mo_Today Is Nothing) Then mo_Today.Refresh
      Case UPD_ASSIGNED_OR_PROJECT
         If Not (mo_Tasks Is Nothing) Then mo_Tasks.Refresh
         If Not (mo_Today Is Nothing) Then mo_Today.Refresh
   End Select
   
   '---for all update types, update any individual task displays, project displays and source displays
   For Each oTasks In mc_Tasks
      oTasks.Refresh
   Next
   For Each oProject In mc_Projects
      oProject.Refresh
   Next
   For Each oSource In mc_Sources
      oSource.Refresh
   Next
End Sub
Private Sub Class_Terminate()

   Debug.Print "clsApplication terminating..."

End Sub


Private Sub mf_Parent_CascadeWindows()

   mf_Parent.Arrange vbCascade

End Sub

Private Sub mf_Parent_LoadProject(sProjName As String)

   Dim oProjects As clsProjects
   
   On Error Resume Next
   If mo_User.Manager Then
      mc_Projects.Item (sProjName)
      If Err.Number <> 0 Then '---the item couldn't be addressed so it isn' t in the collection
         Set oProjects = New clsProjects
         oProjects.Init mo_DataService, mo_ProgConfig, mo_PickList, mo_User.User, sProjName
         mc_Projects.Add oProjects, sProjName
      End If
      mc_Projects.Item(sProjName).LoadProjectForm sProjName
   Else
      MsgBox "You don't have permission to view projects.", vbInformation
   End If

End Sub

Private Sub mf_Parent_LoadSource(sSource As String)

   Dim oSource As clsSource
   Dim iCount As Integer
   
      '---create new one if not already loaded
   On Error Resume Next
   mc_Sources.Item (sSource)
   If Err.Number <> 0 Then '---the item couldn't be addressed so it isn' t in the collection
      Set oSource = New clsSource
      oSource.Init mo_PickList, mo_DataService, mo_ProgConfig
      mc_Sources.Add oSource, sSource
   End If
   '---show the form
   mc_Sources.Item(sSource).Show SHOW_TASKS, sSource

 
   
   
End Sub

Private Sub mf_Parent_LoadTasks(sResource As String)
   
   '---called from the double-click event resource list on the parent MDI form
   
   Dim oTasks As clsTasks
   Dim iCount As Integer
   
   '---create new one if not already loaded
   On Error Resume Next
   mc_Tasks.Item (sResource)
   If Err.Number <> 0 Then '---the item couldn't be addressed so it isn' t in the collection
      Set oTasks = New clsTasks
      oTasks.Init mo_DataService, mo_ProgConfig, mo_PickList
      mc_Tasks.Add oTasks, sResource
   End If
   '---show the form
   mc_Tasks.Item(sResource).Show sResource

End Sub


Private Sub mf_Parent_MenuClick(iIndex As Integer)

   Select Case iIndex
      Case 0
         CreateToday
      Case 1
         CreateProjects
      Case 2
         CreateTasks
      Case 3
         LoadArchive
      Case 4
         LoadAgent
      Case 5
         frmCalendar.Show
         frmCalendar.ZOrder 0
      Case 6
         CreateContacts
      Case 7
         LoadSourceEditor
      Case Else
         ProgNote "Menu item not defined."
   End Select

End Sub

Private Sub mf_Parent_Unloaded(iCancel As Integer, iUnloadMode As Integer)

   EndApplication

End Sub



Private Sub mo_Archive_Unarchived()

   Call UpdateProgram(UPD_UNARCHIVE)

End Sub

Private Sub mo_Projects_ProjectUpdated(tUpdType As UPD_TYPE)
   
   Call UpdateProgram(tUpdType)

End Sub

Private Sub mo_Tasks_TaskUpdated()

   Call UpdateProgram(UPD_TASKS_TASK)

End Sub

Private Sub mo_Today_TaskUpdated()

   Call UpdateProgram(UPD_TODAY_TASK)

End Sub




