VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsArchive"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'---private objects and events
Private mb_NeedRefresh As Boolean
Private WithEvents mf_Archive As frmArchive
Attribute mf_Archive.VB_VarHelpID = -1
Private mo_DataService As clsDataService '---data for the object
Private mo_PickList As clsPickList '---pick list needed for forms
Private mo_ProgConfig As clsProgConfig
Private WithEvents mo_DataProvider As clsDataProvider '---host data
Attribute mo_DataProvider.VB_VarHelpID = -1
'---public objects
Public Event Unarchived()

Public Sub Init(oDataService As clsDataService, oProgConfig As clsProgConfig, oPickList As clsPickList, Optional grd As DataGrid, Optional sProject As String = "")

   '---set module objects
   Set mo_DataService = oDataService
   Set mo_ProgConfig = oProgConfig
   Set mo_PickList = oPickList

End Sub

Public Sub Refresh()

   mb_NeedRefresh = True

End Sub

Public Sub Show()

   If (mf_Archive Is Nothing) Then
      Set mf_Archive = New frmArchive
      Load mf_Archive
      Set mo_DataProvider = New clsDataProvider
      mo_DataProvider.Init mo_DataService, DP_ARCHIVE
      With mf_Archive.grdArchive
         Set .DataSource = mo_DataProvider
         .DataMember = mo_DataProvider.DataMemberName
         .ReBind
         mo_DataProvider.MoveFirst
      End With
   End If
   With mf_Archive
      .WindowState = 0
      .Show
      .ZOrder 0
   End With

End Sub


Private Sub mf_Archive_Activate()
   
   Dim sCap As String
   
   If mb_NeedRefresh Then
      mb_NeedRefresh = False
      SetHourglass
      sCap = mf_Archive.Caption
      mf_Archive.Caption = sCap & " (refreshing archive...)"
      mo_DataProvider.Requery
      mf_Archive.Caption = sCap
      SetReady
   End If
   

End Sub

Private Sub mf_Archive_MenuAction(eArchiveMode As ARCHIVE_MODE)

   Select Case eArchiveMode
      Case DEL_SELECTED
         mo_DataProvider.Delete
      Case UNARC_SELECTED
         If mo_DataService.UnarchiveTask(mo_DataProvider) Then
            mo_DataProvider.Requery
            RaiseEvent Unarchived
         Else
            MsgBox "Error unarchiving this task.", vbCritical
         End If
      Case DEL_ALL
         mo_DataService.ClearArchive
         mo_DataProvider.Requery
   End Select

End Sub



Private Sub mf_Archive_Unloaded()

   Set mf_Archive = Nothing

End Sub

