VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsDataAccess"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'---module objects
Private mo_Conn_Server As ADODB.Connection
Private mo_Conn_Client As ADODB.Connection

Public Sub OpenTable(oRS As ADODB.Recordset, sTable As String)

   oRS.Open sTable, mo_Conn_Client, adOpenDynamic, adLockOptimistic

End Sub


Private Sub Class_Terminate()
    
    On Error Resume Next
    If Not (mo_Conn_Client Is Nothing) Then mo_Conn_Client.Close
    If Not (mo_Conn_Server Is Nothing) Then mo_Conn_Server.Close
    Set mo_Conn_Server = Nothing
    Set mo_Conn_Client = Nothing
    Debug.Print "clsDataAccess terminating..."

End Sub


Public Function Init(sDSN As String, Optional sMsg As String) As Boolean
   
   Dim sConn As String
   
   On Error GoTo TRAP_Init
   
   sConn = "FileDSN=" & sDSN '& "; UID=sa"
   '---create server side connection '---don't need any more
   Set mo_Conn_Server = New ADODB.Connection
   With mo_Conn_Server
      .CursorLocation = adUseServer
      .Open sConn
   End With
   '---create client side connection (for grids which need this) _
   or else you get "The rowset is not bookmarkable" 7004
   Set mo_Conn_Client = New ADODB.Connection
   With mo_Conn_Client
      .CursorLocation = adUseClient
      .Open sConn
   End With
   
   Init = True
   Exit Function

TRAP_Init:
    
   If Err.Number = 3706 Then  '---can't find provider
       sMsg = "You must upgrade your system to the latest version of Microsoft Data Access because the version 4.0 ADO provider was not found.  Please contact your system administrator."
   Else
     sMsg = Err.Description & " (" & CStr(Err.Number) & ")"
   End If
   Init = False
   Exit Function

End Function

Public Function ExecuteSQL(sSQL As String) As Boolean
   
    On Error GoTo TRAP_ExecuteSQL
    
    '---was previously server side cursor
    mo_Conn_Client.Execute sSQL, , adCmdText
    ExecuteSQL = True
    
    Exit Function
   
TRAP_ExecuteSQL:
    MsgBox "Error in Execute SQL: " & Err.Description, vbCritical, "clsDataAccess"
    ExecuteSQL = False
    Exit Function

End Function

Public Function GetGridRecordSet(oRS As Recordset, sSQL As String) As Boolean
   
   Dim sMsg As String
   
   On Error GoTo TRAP_GetGridRecordSet
   
   '---would like to call this but OLE object saving requires server side cursor
   'GetGridRecordSet = GetRecordSet(oRS, sSQL, adOpenDynamic)

   With oRS
      .CursorType = adOpenDynamic
      .LockType = adLockOptimistic
      '---at one time thought this would help with Server side cursor but doesn't
      '.Properties("IRowsetIdentity") = True
      .Open sSQL, mo_Conn_Client
   End With
   
   GetGridRecordSet = True
    
   Exit Function

TRAP_GetGridRecordSet:
   
   sMsg = "Error Description: " & Err.Description & " (" & CStr(Err.Number) & ") for SQL string " & sSQL
   MsgBox "Error in GetGridRecordSet " & sMsg, vbCritical, "Data Service"
   GetGridRecordSet = False
   Exit Function


End Function
Public Function GetRecordSet(oRS As Recordset, sSQL As String, tSetType As CursorTypeEnum) As Boolean
   
   Dim sMsg As String
    
   On Error GoTo TRAP_GetRecordSet
   
   '---23 Mar 01 previously was using Server side cursor and am again since saving OLE object seems to fail
   If tSetType = adOpenStatic Then
      oRS.Open sSQL, mo_Conn_Server, adOpenStatic, adLockReadOnly
   Else
      oRS.Open sSQL, mo_Conn_Server, adOpenKeyset, adLockPessimistic 'adLockOptimistic
   End If
   
   GetRecordSet = True
    
   Exit Function

TRAP_GetRecordSet:
   
   sMsg = "Error Description: " & Err.Description & " (" & CStr(Err.Number) & ") for SQL string " & sSQL
   MsgBox "Error in GetRecordSet " & sMsg, vbCritical, "Data Service"
   GetRecordSet = False
   Exit Function

End Function

Public Function CreateNewRecord(oRS As ADODB.Recordset, sTableName As String) As Boolean
   
   On Error GoTo TRAP
   
   Dim sMsg As String
   
   oRS.Open sTableName, mo_Conn_Server, adOpenKeyset, adLockOptimistic
   oRS.AddNew
   CreateNewRecord = True
    
   Exit Function

TRAP:
   
   sMsg = "Error Description: " & Err.Description & " (" & CStr(Err.Number)
   MsgBox "Error in CreateNewRecord " & sMsg, vbCritical, "Data Service"
   CreateNewRecord = False
   
   Exit Function

End Function
