VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsDataDict"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Enum DP_RECSOURCE
   DP_PROJECTS = 0
   DP_TASKS = 1
   DP_ASSIGN_PROJECTS = 2
   DP_APPOINTMENTS = 3
   DP_MGR_TASKS = 4
   DP_RESOURCES = 5
   DP_ASSIGN_COMPLETE = 6
   DP_ARCHIVE = 7
End Enum






Public Function GetSQLRequest(tDPRequest As DP_RECSOURCE, Optional sCriteria As String = "")

   Dim sRV As String
   
   Select Case tDPRequest
      Case DP_PROJECTS
         sRV = "Select * from Projects order by Name,Version,Start"
      Case DP_TASKS
         If sCriteria = "" Then
            sRV = "Select * from Tasks order by Assigned,Project,Complete"
         Else
            sRV = "Select * from Tasks where Project = " & Chr$(39) & sCriteria & Chr$(39) & " order by Complete,Assigned"
         End If
      Case DP_ASSIGN_PROJECTS
            sRV = "Select * from Tasks Where Status <> " & Chr$(39) & "Terminated" & Chr$(39) & " And Assigned = " & Chr$(39) & sCriteria & Chr$(39) & " order by Project,Status,Priority,Start,Complete"
      Case DP_ASSIGN_COMPLETE
            sRV = "Select * from Tasks Where Status <> " & Chr$(39) & "Terminated" & Chr$(39) & " And Assigned = " & Chr$(39) & sCriteria & Chr$(39) & " And Complete >" & "#" & "01/01/01" & "#" & " order by Project,Status,Priority,Start,Complete"
      Case DP_APPOINTMENTS
         sRV = "Select * from Appointments order by AptDate,AptTime"
      Case DP_MGR_TASKS
         sRV = "Select * from Tasks where Status <> " & Chr$(39) & "Terminated" & Chr$(39) & " order by Complete,Priority,Project,Status"
      Case DP_RESOURCES
         sRV = "Select * from Resources"
      Case DP_ARCHIVE
         sRV = "Select * from Tasks_Archive order by Project"
   End Select

   GetSQLRequest = sRV
   
End Function



Public Function GetTableName(sSource As String) As String

   '---parse Source SQL for table name: e.g., Select * from XXXXX where, or Select * from XXXXX order by...
   '---Updateable tables in this DataDict are Tasks,Projects,Appointments
   
   Dim sRV As String
   
   If InStr(1, sSource, "Tasks") > 0 Then
      sRV = "Tasks"
   ElseIf InStr(1, sSource, "Projects") > 0 Then
      sRV = "Projects"
   ElseIf InStr(1, sSource, "Appointments") > 0 Then
      sRV = "Appointments"
   End If
   
   GetTableName = sRV
   

End Function

