VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 1  'vbDataSource
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsDataProvider"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'---private objects
Private ms_DataMemberName As String
Private WithEvents adoPrimaryRS As Recordset
Attribute adoPrimaryRS.VB_VarHelpID = -1
'---public objects and events
Public Event MoveComplete(lKey As Long)
Public Event DataUpdated()



Public Property Get DataMemberName() As String

   DataMemberName = ms_DataMemberName

End Property


Public Sub Filter(sCriteria As String)

   On Error Resume Next
   
   With adoPrimaryRS
      .Filter = sCriteria
   End With
   

End Sub


Public Sub FindRecord(sCriteria As String)

   Me.PrimaryRecordSet.MoveFirst
   Me.PrimaryRecordSet.Find sCriteria


End Sub

Private Function GetReasonMessage(adReason As ADODB.EventReasonEnum) As String
   
   Dim sMsg As String
   
   Select Case adReason
      Case adRsnAddNew
         sMsg = "New record added"
      Case adRsnClose
         sMsg = "Record set closed"
      Case adRsnDelete
         sMsg = "Record deleted"
      Case adRsnFirstChange
         sMsg = "First change in data"
      Case adRsnMove
         sMsg = "Move in data"
      Case adRsnMoveFirst
         sMsg = "move first"
      Case adRsnMoveLast
         sMsg = "move last"
      Case adRsnMoveNext
         sMsg = "move next"
      Case adRsnMovePrevious
         sMsg = "move previous"
      Case adRsnRequery
         sMsg = "Requery in data"
      Case adRsnResynch
         sMsg = "resync in data"
      Case adRsnUndoAddNew
         sMsg = "undo add new"
      Case adRsnUndoDelete
         sMsg = "undo delete"
      Case adRsnUndoUpdate
         sMsg = "undo update"
      Case adRsnUpdate
         sMsg = "data updated"
      Case Else
         sMsg = "no reason understood"
   End Select
   
   If sMsg = "" Then sMsg = "no reason given"
   GetReasonMessage = sMsg
   
End Function


Public Sub Init(oDataService As clsDataService, tdpRecSource As DP_RECSOURCE, Optional sCriteria As String = "")
   
  Dim oData As clsDataService
  
  Set oData = oDataService
  Set adoPrimaryRS = New ADODB.Recordset
  If Not oData.GetDataProviderRS(adoPrimaryRS, tdpRecSource, sCriteria) Then Err.Raise 1000, "DataProvider", "Could not load data"
  DataMembers.Add "Primary"
  ms_DataMemberName = "Primary"
   
End Sub



Public Property Get PrimaryRecordSet() As Recordset

   Set PrimaryRecordSet = adoPrimaryRS

End Property



Public Sub Sort(sCritera As String)

   adoPrimaryRS.Sort = sCritera

End Sub


Private Sub adoPrimaryRS_FieldChangeComplete(ByVal cFields As Long, ByVal Fields As Variant, ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pRecordset As ADODB.Recordset)
   
   Dim i As Integer
   Dim sMsg As String

   Select Case adStatus
      Case adStatusCancel
         sMsg = "status cancel"
      Case adStatusCantDeny
         sMsg = "status can't deny"
      Case adStatusErrorsOccurred
         sMsg = "status errors occurred"
      Case adStatusOK
         sMsg = "status OK"
      Case adStatusUnwantedEvent
         sMsg = "status unwanted event"
   End Select
   
   If sMsg = "" Then sMsg = "no reason given"
   

End Sub

Private Sub adoPrimaryRS_RecordChangeComplete(ByVal adReason As ADODB.EventReasonEnum, ByVal cRecords As Long, ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pRecordset As ADODB.Recordset)
   
   If adReason = adRsnUpdate Then RaiseEvent DataUpdated

End Sub

Private Sub Class_GetDataMember(DataMember As String, Data As Object)
  Select Case DataMember
  Case "Primary"
    Set Data = adoPrimaryRS
  End Select
End Sub

Private Sub adoPrimaryRS_MoveComplete(ByVal adReason As ADODB.EventReasonEnum, ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pRecordset As ADODB.Recordset)
  
  Dim sMsg As String
  
  On Error GoTo TRAP
  
  RaiseEvent MoveComplete(pRecordset.Fields("ID").Value)
  
  Exit Sub

TRAP:
   
   Select Case Err.Number
      Case 3021 '---Either BOF or EOF is True, or the current record has been deleted. Requested operation requires a current record.
         '---do nothing
      Case Else
         sMsg = "MoveComplete - reason: " & GetReasonMessage(adReason)
         MsgBox "Error in clsDataProvider: " & Err.Description & "--- " & Err.Number & vbCrLf & sMsg
   End Select
   
   Exit Sub
End Sub

Private Sub adoPrimaryRS_WillChangeRecord(ByVal adReason As ADODB.EventReasonEnum, ByVal cRecords As Long, adStatus As ADODB.EventStatusEnum, ByVal pRecordset As ADODB.Recordset)

'   Dim bCancel As Boolean
'
'   If bCancel Then adStatus = adStatusCancel
   
   
End Sub


Public Property Get EditingRecord() As Boolean
  
   Select Case adoPrimaryRS.EditMode
      Case adEditNone
         Debug.Print "No Edit"
      Case adEditInProgress
         Debug.Print "Edit in progress"
      Case adEditAdd
         Debug.Print "Edit add"
      Case adEditDelete
         Debug.Print "EditDelete"
   End Select
  EditingRecord = (adoPrimaryRS.EditMode <> adEditNone)

End Property


Public Property Get AbsolutePosition() As Long
  AbsolutePosition = adoPrimaryRS.AbsolutePosition
End Property

Public Sub AddNew()
     
   adoPrimaryRS.AddNew

End Sub

Public Sub Delete()
  If Not adoPrimaryRS.EOF Then
      adoPrimaryRS.Delete
      MoveNext
  End If
End Sub

Public Sub Requery()
  If adoPrimaryRS.RecordCount <> 0 Then
   adoPrimaryRS.Requery
   DataMemberChanged "Primary"
  End If
End Sub

Public Sub Update()
   
   '---notes from help file
   'Use the UpdateBatch method when modifying a Recordset object in batch update mode to transmit all changes made in a Recordset object to the underlying database.
   'If the Recordset object supports batch updating, then you can cache multiple changes to one or more records locally until you call the UpdateBatch method. If you are editing the current record or adding a new record when you call the UpdateBatch method, ADO will automatically call the Update method to save any pending changes to the current record before transmitting the batched changes to the provider.
   'Note   You should use batch updating only with either a keyset or static cursor.
 
 On Error GoTo TRAP
  
  '---alternate method
     With adoPrimaryRS
       .UpdateBatch adAffectAll
       If .EditMode = adEditAdd Then
         MoveLast
       End If
     End With
 
   
'   With adoPrimaryRS
'      adoPrimaryRS.Move 0 '---known VB ADO bug KB:Q195638 (triggers -2147217842  error)
'      .Update
'      If .EditMode = adEditAdd Then
'         MoveLast
'      End If
'   End With

   Exit Sub

TRAP:
   
   Select Case Err.Number
      Case -2147217842 'The change was canceled during notification; no columns are changed
         Resume 'Next  '---occured on making financial field blank with delete key
      Case 3021 '---eof, bof
         Debug.Print "Data Provider.Update error - EOF,BOF, exiting routine"
         Exit Sub
      Case Else
         Beep
         MsgBox "There was an error in the Data Provider during save. The error is: " & Err.Description & " " & Err.Number
         Exit Sub
   End Select
   
   Exit Sub

End Sub

Public Sub Cancel()
  With adoPrimaryRS
    .CancelUpdate
    If .EditMode = adEditAdd Then
      MoveFirst
    End If
  End With
End Sub

Public Sub MoveFirst()
  
  '---22 Apr 01
  On Error Resume Next
  adoPrimaryRS.MoveFirst
  
  'If Not adoPrimaryRS.EOF And Not adoPrimaryRS.BOF Then adoPrimaryRS.MoveFirst

End Sub

Public Sub MoveLast()
  If adoPrimaryRS.RecordCount <> 0 Then adoPrimaryRS.MoveLast
End Sub

Public Sub MoveNext()
  If Not adoPrimaryRS.EOF Then adoPrimaryRS.MoveNext
  If adoPrimaryRS.EOF And adoPrimaryRS.RecordCount > 0 Then
    'moved off the end so go back
    adoPrimaryRS.MoveLast
  End If
End Sub

Public Sub MovePrevious()
  If Not adoPrimaryRS.BOF Then adoPrimaryRS.MovePrevious
  If adoPrimaryRS.BOF And adoPrimaryRS.RecordCount > 0 Then
    'moved off the end so go back
    adoPrimaryRS.MoveFirst
  End If
End Sub










Private Sub Class_Terminate()

   Set adoPrimaryRS = Nothing
   Debug.Print "clsDataProvider terminating..."

End Sub


