VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsDataService"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Option Explicit

Private mo_DataAccess As clsDataAccess
Private mrs_Tasks As ADODB.Recordset

Public Enum DP_RECSOURCE
   DP_PROJECTS = 0
   DP_TASKS = 1
   DP_ASSIGN_PROJECTS = 2
   DP_APPOINTMENTS = 3
   DP_MGR_TASKS = 4
   DP_RESOURCES = 5
   DP_ASSIGN_COMPLETE = 6
   DP_ARCHIVE = 7
   DP_ASSIGN_PROJECTS_TERM = 8
   DP_ASSIGN_COMPLETE_TERM = 9
   DP_MGR_ASG_TASKS = 10
   DP_CONTACTS = 11
   DP_SOURCE_TASKS = 12
End Enum

Public Sub ArchiveTask(oDP As clsDataProvider)

   Dim sSQL As String
   Dim oRS As New ADODB.Recordset
   Dim oField As ADODB.Field
   
   If mo_DataAccess.CreateNewRecord(oRS, "Tasks_Archive") Then
      With oDP.PrimaryRecordSet
         For Each oField In oDP.PrimaryRecordSet.Fields
            Select Case oField.Name
               Case "ID"
                  '---do nothing, auto number
               Case "Start", "Complete", "Created"
                  If Not IsNull(.Fields(oField.Name)) Then oRS.Fields(oField.Name).Value = .Fields(oField.Name).Value
               Case Else
                  oRS.Fields(oField.Name).Value = .Fields(oField.Name).Value
            End Select
         Next
      End With
      oRS.Update
   Else
      MsgBox "Error Archiving: " & Err.Description
   End If

End Sub







   








Public Sub ArchiveTasks(sResource As String)

   Dim sSQLInsert As String
   Dim sSQLDelete As String
   
   If sResource = "" Then
      sSQLInsert = "Insert into Tasks_Archive Select * from Tasks where Status = " & Chr$(39) & "Terminated" & Chr$(39)
      sSQLDelete = "Delete from Tasks where Status = " & Chr$(39) & "Terminated" & Chr$(39)
   Else
      sSQLInsert = "Insert into Tasks_Archive Select * from Tasks where Status = " & Chr$(39) & "Terminated" & Chr$(39) & " and Assigned = " & Chr$(39) & sResource & Chr$(39)
      sSQLDelete = "Delete from Tasks where Status = " & Chr$(39) & "Terminated" & Chr$(39) & " and Assigned = " & Chr$(39) & sResource & Chr$(39)
   End If
   If Not mo_DataAccess.ExecuteSQL(sSQLInsert) Then
      MsgBox "Error archiving tasks", vbCritical
   Else
      If Not mo_DataAccess.ExecuteSQL(sSQLDelete) Then
         MsgBox "Error deleting archived tasks", vbCritical
      End If
   End If
      
End Sub


Public Sub ClearArchive()

   Dim sSQL As String
   
   sSQL = "Delete from Tasks_Archive"
   If Not mo_DataAccess.ExecuteSQL(sSQL) Then MsgBox "Error clearing Archive table"

End Sub

Public Sub DeleteProjTask(sProj As String)

   Dim sSQL As String
   
   sSQL = "Delete from Tasks where Project = " & Chr$(39) & sProj & Chr$(39)
   If Not mo_DataAccess.ExecuteSQL(sSQL) Then Err.Raise 1000, "DataService", "Unable to delete project tasks"
   
End Sub













Public Function GetCategory() As ADODB.Recordset
   
   Dim oRS As New ADODB.Recordset
   Dim sSQL As String
   
   sSQL = "Select * from Category order by ID"
   If Not mo_DataAccess.GetRecordSet(oRS, sSQL, adOpenStatic) Then
      Err.Raise 1000, "DataService", "Failed to get Category"
   Else
      Set GetCategory = oRS
   End If
   
End Function

Public Function GetUserProfile(sUser As String, bManager As Boolean, sPassword As String) As Boolean

   Dim sSQL As String
   Dim oRS As New ADODB.Recordset
   Dim bRV As Boolean
   
   sSQL = "Select * from Resources where Resource = " & Chr$(39) & sUser & Chr$(39)
   If Not mo_DataAccess.GetRecordSet(oRS, sSQL, adOpenStatic) Then
      Err.Raise 1000, "DataService", "Failed to open Resources for finding user password."
   Else
      If oRS.RecordCount = 0 Then
         bRV = False
      Else
         sPassword = oRS.Fields("Password").Value & ""
         bManager = IIf(oRS.Fields("Authority").Value = 0, True, False)
         bRV = True
      End If
   End If
   
   GetUserProfile = bRV
   
End Function

Public Function GetDataProviderRS(oRS As Recordset, tdpRecSource As DP_RECSOURCE, Optional sCriteria As String = "") As Boolean
   
   Dim sSQL As String
   
   Select Case tdpRecSource
      Case DP_PROJECTS
         If sCriteria = "" Then
            sSQL = "Select * from Projects order by Name,Start"
         Else
            sSQL = "Select * from Projects where Name = " & Chr$(39) & sCriteria & Chr$(39) & " order by Name,Start"
         End If
      Case DP_TASKS
         If sCriteria = "" Then
            sSQL = "Select * from Tasks order by Assigned,Project,Complete"
         Else
            sSQL = "Select * from Tasks where Project = " & Chr$(39) & sCriteria & Chr$(39) & " order by Status,Complete,Assigned"
         End If
      Case DP_ASSIGN_PROJECTS
            sSQL = "Select * from Tasks Where Status <> " & Chr$(39) & "Terminated" & Chr$(39) & " And Assigned = " & Chr$(39) & sCriteria & Chr$(39) & " order by Project,Status,Priority,Start,Complete"
      Case DP_ASSIGN_PROJECTS_TERM
            sSQL = "Select * from Tasks Where Assigned = " & Chr$(39) & sCriteria & Chr$(39) & " order by Project,Status,Priority,Start,Complete"
      Case DP_ASSIGN_COMPLETE
            sSQL = "Select * from Tasks Where Status <> " & Chr$(39) & "Terminated" & Chr$(39) & " And Assigned = " & Chr$(39) & sCriteria & Chr$(39) & " And Complete >" & "#" & "01/01/01" & "#" & " order by Project,Status,Priority,Start,Complete"
      Case DP_ASSIGN_COMPLETE_TERM
            sSQL = "Select * from Tasks Where Assigned = " & Chr$(39) & sCriteria & Chr$(39) & " And Complete >" & "#" & "01/01/01" & "#" & " order by Project,Status,Priority,Start,Complete"
      Case DP_APPOINTMENTS
         sSQL = "Select * from Appointments order by AptDate,AptTime"
      Case DP_MGR_TASKS
         sSQL = "Select * from Tasks where Status <> " & Chr$(39) & "Terminated" & Chr$(39) & " order by Complete,Priority,Project,Status"
      Case DP_MGR_ASG_TASKS
         sSQL = "Select * from Tasks where Status <> " & Chr$(39) & "Terminated" & Chr$(39) & " order by Complete, Assigned, Priority, Project,Status"
      Case DP_RESOURCES
         sSQL = "Select * from Resources"
      Case DP_ARCHIVE
         sSQL = "Select * from Tasks_Archive order by Project,ID"
      Case DP_CONTACTS
         sSQL = "Select * from Contacts order by LastName"
       Case DP_SOURCE_TASKS
         sSQL = "Select * from Tasks where Source = " & Chr$(39) & sCriteria & Chr$(39) & " order by Project, Status,Assigned,Complete"
   End Select
   
   GetDataProviderRS = mo_DataAccess.GetGridRecordSet(oRS, sSQL)
   
End Function


Public Function GetPriorities() As ADODB.Recordset
   
   Dim oRS As New ADODB.Recordset
   Dim sSQL As String
   
   sSQL = "Select * from Priority order by ID"
   If Not mo_DataAccess.GetRecordSet(oRS, sSQL, adOpenStatic) Then
      Err.Raise 1000, "DataService", "Failed to get Priorities"
   Else
      Set GetPriorities = oRS
   End If

End Function



Public Function GetResources() As ADODB.Recordset

   Dim oRS As New ADODB.Recordset
   Dim sSQL As String
   
   sSQL = "Select * from Resources order by Authority,Resource"
   If Not mo_DataAccess.GetRecordSet(oRS, sSQL, adOpenStatic) Then
      Err.Raise 1000, "DataService", "Failed to get Resources"
   Else
      Set GetResources = oRS
   End If
   
End Function

Public Function GetSources() As ADODB.Recordset
   
   Dim oRS As New ADODB.Recordset
   Dim sSQL As String
   
   sSQL = "Select * from Source order by ID"
   If Not mo_DataAccess.GetRecordSet(oRS, sSQL, adOpenStatic) Then
      Err.Raise 1000, "DataService", "Failed to get Sources"
   Else
      Set GetSources = oRS
   End If

End Function



   



Public Sub LoadProjects(lst As Control)
   
   Dim sSQL As String
   Dim oRS As New ADODB.Recordset
   
   If Not mo_DataAccess.GetRecordSet(oRS, "Select * from Projects order by Name", adOpenStatic) Then
      Err.Raise 1000, "clsTasks", "Could not get project list"
   Else
      If Not oRS.EOF Then oRS.MoveFirst
      Do Until oRS.EOF
         With lst
            .AddItem oRS.Fields("Name").Value
            .ItemData(.NewIndex) = oRS.Fields("ID").Value
            oRS.MoveNext
         End With
      Loop
   End If
   oRS.Close
   Set oRS = Nothing
   
End Sub













Public Function Init(sDSN As String, Optional sMsg As String) As Boolean

   Set mo_DataAccess = New clsDataAccess
   If mo_DataAccess.Init(sDSN, sMsg) Then
      '---get tasks
'      Set mrs_Tasks = New ADODB.Recordset
'      Init = mo_DataAccess.GetGridRecordSet(mrs_Tasks, "Tasks")
      Init = True
   Else
      Init = False
   End If
   
End Function









Public Function UnarchiveTask(oDP As clsDataProvider) As Boolean
   
   Dim sSQL As String
   Dim oRS As New ADODB.Recordset
   Dim oField As ADODB.Field
   Dim bRV As Boolean
   
   If oDP.PrimaryRecordSet.RecordCount <> 0 Then
      If mo_DataAccess.CreateNewRecord(oRS, "Tasks") Then
         With oDP.PrimaryRecordSet
            For Each oField In oDP.PrimaryRecordSet.Fields
               Select Case oField.Name
                  Case "ID"
                     '---do nothing, auto number
                  Case "Start", "Complete", "Created"
                     If Not IsNull(.Fields(oField.Name)) Then oRS.Fields(oField.Name).Value = .Fields(oField.Name).Value
                  Case Else
                     oRS.Fields(oField.Name).Value = .Fields(oField.Name).Value
               End Select
            Next
         End With
         oRS.Update
         oDP.Delete
         bRV = True
      Else
         bRV = False
      End If
   Else
      bRV = True
   End If
   UnarchiveTask = bRV

End Function
Private Sub Class_Initialize()

   Debug.Print "clsDataService init"

End Sub

Private Sub Class_Terminate()
    
    Set mo_DataAccess = Nothing
    
End Sub






