VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsProgConfig"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const INI_FILE = "AdminDirector.ini"
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long


Private Function ReadINISetting(strSection As String, strKeyName As String, Optional strDefault As String = "") As String
  
  Dim strBuffer As String * 256
  Dim intSize As Integer

  On Error GoTo PROC_ERR

  intSize = GetPrivateProfileString(strSection, strKeyName, strDefault, strBuffer, 256, App.Path & "\" & INI_FILE)

  ReadINISetting = Left$(strBuffer, intSize)

  Exit Function
  
PROC_ERR:
   ReadINISetting = ""
   Exit Function
   
End Function

Public Function GetManager() As String

   GetManager = ReadINISetting("Security", "Manager", "")

End Function

Public Function GetTemplate(tRptType As RPT_TYPE, Optional tRptSubType As RPT_SUBTYPE = -1) As String

   Dim sRV As String
   
   Select Case tRptType
      Case RPT_ASSIGNMENTS
         Select Case tRptSubType
            Case RPT_BYPROJ
               sRV = "Assign_Projects.rpt"
            Case RPT_BY_COMPLETE
               sRV = "Assign_Dates.rpt"
            Case Else
               MsgBox "Report not defined"
         End Select
      Case RPT_TASK
         sRV = "Task.rpt"
      Case RPT_TODAY
         sRV = "Today.rpt"
      Case RPT_TODAY_ASG
         sRV = "Today_Asg.rpt"
      Case RPT_APT
         sRV = "Apt.rpt"
      Case RPT_PROJECT
         sRV = "ProjectReport.rpt"
      Case RPT_APT_SUM
         sRV = "AptSum.rpt"
      Case RPT_MASTER_TASK
         sRV = "TaskMaster.rpt"
      Case RPT_MASTER_PROJECT_STATUS
         sRV = "ProjectMasterStatus.rpt"
      Case RPT_MASTER_PROJECT_ASSIGNED
         sRV = "ProjectMasterAssigned.rpt"
      Case RPT_SOURCE
         sRV = "Source.rpt"
      Case RPT_PROJECT_LIST
         sRV = "ProjectList.rpt"
   End Select
   
   GetTemplate = ReadINISetting("Paths", "Templates", "") & "\" & sRV

End Function

Public Function GetRptOutputPath() As String

   GetRptOutputPath = ReadINISetting("Paths", "Reports", "") & "\"

End Function



