VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsProjects"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'---module objects
Private mo_DataService As clsDataService '---gets data
Private ms_Project As String
Private ms_Manager As String
Private WithEvents mf_Projects As frmProjects '---hosts all projects
Attribute mf_Projects.VB_VarHelpID = -1
Private WithEvents mo_DataProvider As clsDataProvider '---host data
Attribute mo_DataProvider.VB_VarHelpID = -1
Private WithEvents mf_Project As frmProject '---an individual project's data
Attribute mf_Project.VB_VarHelpID = -1
Private mo_PickList As clsPickList '---pick list for all forms
Private ml_CurProjID As Long '---ID of currently selected project
Private ms_CurProjName As String '---name of currently selected project
Private mo_ProgConfig As clsProgConfig
Private mb_NeedRefresh As Boolean
Private mb_RefreshProjects As Boolean
Public Event ProjectUpdated(tUpdType As UPD_TYPE)

Public Sub Refresh()
   
   mb_NeedRefresh = True

End Sub
Public Sub Init(oDataService As clsDataService, oProgConfig As clsProgConfig, oPickList As clsPickList, sManager As String, Optional sProjName As String = "")

   '---init module objects
   Set mo_DataService = oDataService
   Set mo_PickList = oPickList
   Set mo_ProgConfig = oProgConfig
   ms_Manager = sManager
   '---create the project data
   Set mo_DataProvider = New clsDataProvider
   mo_DataProvider.Init mo_DataService, DP_PROJECTS, sProjName

End Sub


Public Sub LoadProjectForm(sProjName As String)

   '---set module identifer
   ms_Project = sProjName
   '---this is probably not needed since the data provider, as loaded from clsApplication _
   has only one record
   mo_DataProvider.FindRecord "Name = " & Chr$(39) & sProjName & Chr$(39)
   '---load project form
   If (mf_Project Is Nothing) Then
      Set mf_Project = New frmProject
      Load mf_Project
      mf_Project.Manager = ms_Manager
      '---set mode on project form
      mf_Project.Mode = PROJ_EDIT
      Call LoadProjectData
      '---lock proj name since by design it can't be changed here
      mf_Project.txtName.Enabled = False
      '---load tasks
      Call LoadProjectTasks
   End If
   '---show form
   With mf_Project
      .WindowState = 0
      .Show
      .ZOrder 0
   End With
 

End Sub



Private Sub LoadProjectData()

   With mo_DataProvider
      mf_Project.ID = .PrimaryRecordSet.Fields("ID").Value
      mf_Project.ProjName = .PrimaryRecordSet.Fields("Name").Value
      mf_Project.Description = .PrimaryRecordSet.Fields("Description").Value
      mf_Project.Manager = .PrimaryRecordSet.Fields("Manager").Value
      mf_Project.Start = .PrimaryRecordSet.Fields("Start").Value
      mf_Project.Complete = .PrimaryRecordSet.Fields("Complete").Value
   End With

End Sub


Private Sub LoadProjectTasks()
   
   mf_Project.LoadTasks mo_DataService, mo_ProgConfig, mo_PickList
   mf_Project.SetTaskState True

End Sub

Public Sub LoadQuickView(lst As ListBox)
   
   mo_DataProvider.MoveFirst
   Do Until mo_DataProvider.PrimaryRecordSet.EOF
      lst.AddItem mo_DataProvider.PrimaryRecordSet("Name").Value
      mo_DataProvider.PrimaryRecordSet.MoveNext
   Loop
   
End Sub

Public Sub RefreshProjects()

   mb_RefreshProjects = True

End Sub

Private Sub SetRecordsetValues()
   
   With mo_DataProvider
      .PrimaryRecordSet.Fields("Name").Value = mf_Project.ProjName
      .PrimaryRecordSet.Fields("Description").Value = mf_Project.Description
      .PrimaryRecordSet.Fields("Manager").Value = mf_Project.Manager
      .PrimaryRecordSet.Fields("Start").Value = mf_Project.Start
      .PrimaryRecordSet.Fields("Complete").Value = mf_Project.Complete
      .Update
   End With
   
End Sub

Public Sub Show()

   If (mf_Projects Is Nothing) Then
      SetHourglass
      '---load the form
      Set mf_Projects = New frmProjects
      '---load project list
      With mf_Projects.grdProjects
         Set .DataSource = mo_DataProvider
         .DataMember = mo_DataProvider.DataMemberName
         .ReBind
         mo_DataProvider.MoveFirst
      End With
      SetReady
   End If
   
   With mf_Projects
      .WindowState = 0
      .Show
      .ZOrder 0
   End With
   
End Sub

Private Sub UpdateGrid()

   '---update the list of all projects on frmProjects
   mo_DataProvider.Requery
   If Not (mf_Projects Is Nothing) Then mf_Projects.grdProjects.ReBind

End Sub

Private Sub Class_Terminate()
   
   On Error Resume Next
   If Not (mf_Projects Is Nothing) Then
      Unload mf_Projects
      Set mf_Projects = Nothing
   End If
   Set mo_DataService = Nothing
   Set mo_DataProvider = Nothing
   Set mo_PickList = Nothing
   Set mo_ProgConfig = Nothing
   Debug.Print "clsProjects terminating..."
   
End Sub




Private Sub mf_Project_Activate()

   Dim sCap As String
   
   If mb_NeedRefresh Then
      mb_NeedRefresh = False
      SetHourglass
      sCap = mf_Project.Caption
      mf_Project.Caption = sCap & " (refreshing project tasks...)"
      mf_Project.RefreshTasks
      '---old code
      'LoadProjectTasks
      mf_Project.Caption = sCap
      SetReady
   End If

End Sub

Private Sub mf_Project_ProjectTaskUpdate()
   
   RaiseEvent ProjectUpdated(UPD_PROJECT_TASK)
   
End Sub



Private Sub mf_Project_Unloaded()

   Set mf_Project = Nothing
   go_Application.RemoveProjectMember ms_Project
   
End Sub



Private Sub mf_Projects_Activate()
   
   Dim sCap As String
   
   If mb_RefreshProjects Then
      mb_RefreshProjects = False
      SetHourglass
      sCap = mf_Projects.Caption
      mf_Projects.Caption = sCap & " (refreshing project data...)"
      mo_DataProvider.Requery
      mf_Projects.Caption = sCap
      SetReady
   End If
End Sub

Private Sub mf_Projects_Report()
   
   Dim oReport As clsReports
   
   Set oReport = New clsReports
   oReport.DoReport mo_DataProvider.PrimaryRecordSet, RPT_PROJECT_LIST, RPT_VIEW


End Sub


Private Sub mo_DataProvider_DataUpdated()

   go_Application.UpdateProgram UPD_PROJECT_MOD

End Sub

Private Sub mo_DataProvider_MoveComplete(lKey As Long)

   '---set key and name
   ml_CurProjID = lKey
   '---only show selected project when frmProjects exists and record is a real value _
   lKey will be 0 during AddNew prior to update.  This event is fired when user moves _
   grid and when data changes
   If Not (mf_Projects Is Nothing) And lKey <> 0 Then
      ms_CurProjName = mo_DataProvider.PrimaryRecordSet.Fields("Name").Value
   End If

End Sub

Private Sub mf_Project_Save()
         
   '---fired from individual project form (frmProject)
   With mo_DataProvider
      If mf_Project.Mode = PROJ_ADD Then
         .AddNew
         Call SetRecordsetValues
         '---obtain the new ID for the project just saved
         .MoveLast
         mf_Project.ID = .PrimaryRecordSet.Fields("ID").Value
         '---change project mode now that project is saved
         mf_Project.Mode = PROJ_EDIT
         '---load task now that the proj is saved
         Call LoadProjectTasks
         RaiseEvent ProjectUpdated(UPD_PROJECT_ADD_DEL)
      Else '---editing project record
         .FindRecord "ID =" & mf_Project.ID
         Call SetRecordsetValues
      End If
   End With
   '---enable task actions
   mf_Project.SetTaskState True
   '---update project grid on parent frmProjects
   mo_DataProvider.Requery
   '---old line
   'Call UpdateGrid
   
End Sub
Private Sub mf_Projects_Modify(tMode As PROJ_MODE)
   
   Dim bOpen As Boolean
   Dim i As Integer
   
   Select Case tMode
      Case PROJ_ADD
         '---load project form
         Set mf_Project = New frmProject
         Load mf_Project
         mf_Project.Manager = ms_Manager
         '---set mode on project form
         mf_Project.Mode = tMode
         '---show form
         mf_Project.Show
      Case PROJ_DEL
         '---test to see if project is open
         For i = 0 To Forms.Count - 1
               If Forms(i).Name = "frmProject" Then
                  If Forms(i).ProjName = ms_CurProjName Then
                     bOpen = True
                     Exit For
                  End If
               End If
         Next i
         If bOpen Then
            MsgBox "You have this project open for work. You must close it before you can delete it.", vbCritical
         Else
            If MsgBox("Confirm delete for project: " & ms_CurProjName & " and all associated tasks.", vbQuestion + vbYesNo) = vbYes Then
              '---delete all associated tasks
               mo_DataService.DeleteProjTask ms_CurProjName
               '---delete the project
               mo_DataProvider.Delete
               '---update project grid (don't need this line)
               'Call UpdateGrid
               RaiseEvent ProjectUpdated(UPD_PROJECT_ADD_DEL)
            End If
         End If
         
   End Select

End Sub

Private Sub mf_Projects_Unloaded()
   
   Set mf_Projects = Nothing

End Sub


