VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsReports"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private mo_ProgConfig As clsProgConfig


Public Sub DoReport(oRS As ADODB.Recordset, tRptType As RPT_TYPE, tRptMode As RPT_MODE, Optional sRptOutputName As String = "", Optional tRptSubType As RPT_SUBTYPE = -1, Optional tExpType As EXP_TYPE = EXP_NONE, Optional sFolderName As String = "")
   
   Dim crxApplication As New CRAXDRT.Application
   Dim rpt As CRAXDRT.Report
   Dim sTemplate As String

   '---get report name
   sTemplate = mo_ProgConfig.GetTemplate(tRptType, tRptSubType)
   '---open the report and connect it to the data
   Set rpt = crxApplication.OpenReport(sTemplate, 1)
   rpt.Database.SetDataSource oRS
   '---determine report output mode
   Select Case tRptMode
      Case RPT_EXPORT
         Call ExportReport(rpt, sRptOutputName, tExpType, sFolderName)
      Case RPT_VIEW
         Call ViewReport(rpt)
      Case RPT_PRINT
         Call PrintReport(rpt)
   End Select

End Sub

Private Sub ExportReport(rCrystal As CRAXDRT.Report, sRptName As String, tExpType As EXP_TYPE, sFolderName As String)
     
   Dim sRptExt As String
   
   With rCrystal.ExportOptions
      .DestinationType = crEDTDiskFile
      Select Case tExpType
         Case EXP_NONE, EXP_WORD '---none specified or word
            .FormatType = crEFTWordForWindows
            sRptExt = ".doc"
         Case EXP_RTF
            .FormatType = crEFTExactRichText
            sRptExt = ".rtf"
         Case EXP_PDF
            .FormatType = crEFTPortableDocFormat
            sRptExt = ".pdf"
         Case EXP_EXCEL
            .FormatType = crEFTExcel80
            sRptExt = ".xls"
      End Select
     .DiskFileName = mo_ProgConfig.GetRptOutputPath & sFolderName & "\" & sRptName & sRptExt
   End With
   
   rCrystal.Export (False)

End Sub







Private Sub PrintReport(rCrystal As CRAXDRT.Report)

   With rCrystal.ExportOptions
      .Parent.PrintOut
   End With
   
End Sub

Private Sub ViewReport(rCrystal As CRAXDRT.Report)
   
  Dim fRpt As New frmRptViewer
   
   Load fRpt
   
   With fRpt.cryViewer
      .ReportSource = rCrystal
     .ViewReport
     .Zoom 85
   End With
   
   fRpt.Show

End Sub








Private Sub Class_Initialize()

   Set mo_ProgConfig = New clsProgConfig

End Sub


Private Sub Class_Terminate()

  Debug.Print "clsReports terminating..."

End Sub


