VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSystemAgent"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'---I stole this from somewhere, but can't remember where (MSDN??)
'***********************************************************
'Declares
'***********************************************************
Private Declare Function ShellExecute Lib "shell32.dll" Alias _
    "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, _
    ByVal lpFile As String, ByVal lpParameters As String, _
    ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

'***********************************************************
'Private Data
'***********************************************************
Private Type ShortCut
    Name As String * 80
    Path As String * 150
End Type

Private WithEvents MSAgent As Agent
Attribute MSAgent.VB_VarHelpID = -1
Private AgentChar As IAgentCtlCharacterEx
Private mRequest As IAgentCtlRequest

Private fso As New FileSystemObject
Private ShortCuts() As ShortCut

Private mblnAlwaysFast As Boolean
Private mstrReturn As String
Private mlngTotalLines As Long
Private mlngConfidenceMin As Long
Private mintListen As Integer
Private mblnWasVisible As Boolean

'***********************************************************
'Events
'***********************************************************
Public Event AddFolderComplete()
Public Event AddingFolder(Name As String, Path As String)
Public Event Reading(line As Long, TotalLines As Long, Cancel As Boolean)

Public Sub Speak(sText As String, bHide As Boolean)
   
   AgentChar.StopAll
   mblnWasVisible = isAgentVisible
   AgentChar.Speak sText
   If bHide Then AgentChar.Hide
   
End Sub

'***********************************************
'Create a new instance of the Agent Control and
'Load the Default character.
'***********************************************
Private Sub Class_Initialize()
    Set MSAgent = New Agent
    On Error Resume Next
    MSAgent.Characters.Load "merlin.acs", "merlin.acs"
    Set AgentChar = MSAgent.Characters("merlin.acs")
    ReDim ShortCuts(0)
    mlngConfidenceMin = 0
    AgentChar.Commands.Caption = "System Agent"
    AgentChar.Commands.Voice = "System Agent"
    AgentChar.Commands.Visible = True
    
End Sub

'***********************************************
'Hide the agent, unload the character and destroy
'our objects before terminating the class.
'***********************************************
Private Sub Class_Terminate()
    
   On Error Resume Next
    If AgentChar.Visible = True Then
        AgentChar.StopAll
        AgentChar.Hide mblnAlwaysFast
    End If
    
    Set AgentChar = Nothing
    MSAgent.Characters.Unload "merlin.acs"
    Set MSAgent = Nothing
End Sub

'***********************************************
'Tests if the agent is visible. If the agent is
'not visible it will be shown
'***********************************************
Private Function isAgentVisible() As Boolean
    If AgentChar.Visible Then
        isAgentVisible = True
    Else
        isAgentVisible = False
        AgentChar.Show mblnAlwaysFast
    End If
End Function

'***********************************************
'Gets the agent to appear and ask a question.
'The agent then waits for a response and returns
'the response to the calling program.
'***********************************************
Public Function AskQuestion(Question As String, Answers() As String, Optional MinConfidence As Long) As String
    Dim objCmd As IAgentCtlCommandEx
    Dim blnVisible As Boolean
    Dim i As Long
    
    '************************************
    'Disable And Hide All Commands
    '************************************
    For Each objCmd In AgentChar.Commands
        objCmd.Enabled = False
        objCmd.Visible = False
    Next
        
    '************************************
    'Add Answers as commands
    '************************************
    For i = LBound(Answers) To UBound(Answers)
        AgentChar.Commands.Add Answers(i), Answers(i), Answers(i), True, True
    Next
               
    '************************************
    'Set Minimum Confidence Level
    'If this level is not reached or
    'exceeded this function will return
    'an empty string
    '************************************
    If IsMissing(MinConfidence) Then
        mlngConfidenceMin = 0
    Else
        mlngConfidenceMin = MinConfidence
    End If
    
    blnVisible = isAgentVisible()
    
    '************************************
    'Ask Question
    '************************************
    Set mRequest = AgentChar.Speak(Question)
    
    Do While mRequest.Status
        DoEvents
    Loop
    
    '************************************
    'Wait for a response
    'Automatically start listening and
    'keep listening until an answer is given
    '************************************
    mstrReturn = " "
    mintListen = False
    
    Do While mstrReturn = " "
        DoEvents
        If mintListen = False Then AgentChar.Listen (True)
    Loop
    
    If blnVisible = False Then AgentChar.Hide mblnAlwaysFast
    
    '************************************
    'Remove Answers and enable previous
    'commands
    '************************************
    For Each objCmd In AgentChar.Commands
        If objCmd.Enabled Then
            AgentChar.Commands.Remove objCmd.Caption
        Else
            objCmd.Visible = True
            objCmd.Enabled = True
        End If
    Next
    
    Set objCmd = Nothing
    
    AskQuestion = mstrReturn
End Function

Private Sub MSAgent_Command(ByVal UserInput As Object)
    Dim blnCancel As Boolean
    
    '***********************************************
    'The the confidence level the user set has not
    'been reached or exceeded then return an empty
    'string
    '***********************************************
    If UserInput.Confidence >= mlngConfidenceMin Then
        mstrReturn = UserInput.Name
    Else
        mstrReturn = ""
    End If
End Sub

'***********************************************
'Always Fast Determines if the show or hide
'animations should be played. If true the animations
'are not played
'***********************************************
Public Property Get AlwaysFast() As Boolean
    AlwaysFast = mblnAlwaysFast
End Property

Public Property Let AlwaysFast(ByVal bolNewValue As Boolean)
    mblnAlwaysFast = bolNewValue
End Property

'***********************************************
'User Access to the AddFolder Subroutine
'Necessary to raise the proper events since
'AddFolder can be called recursively
'***********************************************
Public Sub AddFolderCommands(strFolder As String, strFileMask As String, blnRecurse As Boolean)
    Dim fldr As Scripting.Folder
    
    If fso.FolderExists(strFolder) Then
        Set fldr = fso.GetFolder(strFolder)
        Call AddFolder(fldr, strFileMask, blnRecurse)
    End If
    RaiseEvent AddFolderComplete
End Sub

'***********************************************
'Loads a folder as commands based on the filemask.
'Can be recursively called to load subfolders
'***********************************************
Private Sub AddFolder(rfldr As Scripting.Folder, strFileMask As String, blnRecurse As Boolean)
    Dim f As Scripting.File
    Dim strName As String
    Dim x As Long
    Dim fldr As Scripting.Folder
    
    If fso.FolderExists(rfldr.Path) Then
    
        RaiseEvent AddingFolder(rfldr.Name, rfldr.Path)
        DoEvents
    
        '*****************************************************************
        'Check each file to see if it fits the mask
        '*****************************************************************
        For Each f In rfldr.Files
            If f.Name Like strFileMask Then
                x = InStrRev(f.Name, ".", , vbTextCompare)
                If x <> 0 Then
                    strName = Trim$(Left$(f.Name, x - 1))
                Else
                    strName = Trim$(f.Name)
                End If
                
                Call AddCommand(strName, Trim$(f.Path))
            End If
        Next
        
        '*****************************************************************
        'If the Recurse flag is true then recursively call this subroutine
        'for each subfolder found
        '*****************************************************************
        If blnRecurse Then
            For Each fldr In rfldr.SubFolders
                Call AddFolder(fldr, strFileMask, blnRecurse)
            Next
        End If
    End If
End Sub

'***********************************************
'Adds a command to the agent and to the shortcuts
'array
'***********************************************
Private Sub AddCommand(strName As String, strPath As String)
    '*****************************************************************
    'If there is duplicate items ignore all but the first instance.
    '*****************************************************************
    On Error GoTo EndCmd
    
    AgentChar.Commands.Add strName, strName, strName, True, True
    
    ReDim Preserve ShortCuts(UBound(ShortCuts) + 1)
    
    ShortCuts(UBound(ShortCuts)).Name = strName
    ShortCuts(UBound(ShortCuts)).Path = strPath
EndCmd:

End Sub

'***********************************************
'Runs a specific program by calling shellexecute
'***********************************************
Private Sub RunShortCut(strCommand As String)
'    Dim i As Long
'    Dim lngReturn As Long
'
'    For i = 1 To UBound(ShortCuts)
'        If UCase$(Trim$(ShortCuts(i).Name)) = UCase$(strCommand) Then
'            AgentChar.StopAll
'            AgentChar.Play "Acknowledge"
'            lngReturn = ShellExecute(frmMain.hwnd, "Open", Trim$(ShortCuts(i).Path), "", "", vbNormalFocus)
'            AgentChar.Speak "Opening " & Trim$(ShortCuts(i).Name)
'            i = UBound(ShortCuts)
'        End If
'    Next
End Sub

'**********************************************
'Parse the input into an array of lines, then
'the agent can read each line seperately so
'we do not run into problems with exceeding the
'agents maximum number of characters in the
'speek method.
'**********************************************
Public Sub ReadText(strText As String)
    
    Dim strLine() As String
    Dim i As Long
    Dim blnCancel As Boolean
    
    On Error GoTo TRAP
    blnCancel = False
    
    strLine = Split(strText, ".")
    '**********************************************
    'If the last element is empty then remove it
    '**********************************************
    If Len(Trim$(strLine(UBound(strLine)))) = 0 Then
        ReDim Preserve strLine(UBound(strLine) - 1)
    End If
    
    AgentChar.StopAll
    
    mblnWasVisible = isAgentVisible
    
    mlngTotalLines = UBound(strLine) + 1
    
    RaiseEvent Reading(1, mlngTotalLines, blnCancel)
    DoEvents
    If blnCancel = True Then
        AgentChar.StopAll
        If mblnWasVisible Then AgentChar.Hide mblnAlwaysFast
    Else
        For i = LBound(strLine) To UBound(strLine)
            AgentChar.Speak strLine(i) & " \Mrk=" & i + 2 & "\"
        Next
    End If
Exit Sub

TRAP:
   MsgBox "An error occured in the Read text routine: " & Err.Description
   Exit Sub
End Sub


'***********************************************
'Bookmarks are used for the ReadText Method. This
'Raises the Reading Event after each line has
'been spoken, so the user can sync something to
'the spoken text.
'***********************************************
Private Sub MSAgent_Bookmark(ByVal BookmarkID As Long)
    Dim blnCancel As Boolean
            
    If blnCancel = True Or BookmarkID = mlngTotalLines + 1 Then
        AgentChar.StopAll
        If mblnWasVisible = False Then AgentChar.Hide mblnAlwaysFast
    Else
        RaiseEvent Reading(BookmarkID, mlngTotalLines, blnCancel)
        DoEvents
    End If
End Sub

'**********************************************
'Parse the input into an array of lines, then
'the agent can read each line seperately so
'we do not run into problems with exceeding the
'agents maximum number of characters in the
'speek method.
'**********************************************
Public Sub ReadTextandWait(strText As String)
    Dim strLine() As String
    Dim i As Long
    Dim blnCancel As Boolean
    Dim objRequest As IAgentCtlRequest
    Dim blnWasVisible As Boolean
    Dim lngTotalLines As Long
    
    blnCancel = False
    
    strLine = Split(strText, ".")
    '**********************************************
    'If the last element is empty then remove it
    '**********************************************
    If Len(Trim$(strLine(UBound(strLine)))) = 0 Then
        ReDim Preserve strLine(UBound(strLine) - 1)
    End If
    
    AgentChar.StopAll
    
    blnWasVisible = isAgentVisible
    
    lngTotalLines = UBound(strLine) + 1
    
    For i = LBound(strLine) To UBound(strLine)
        RaiseEvent Reading(i + 1, lngTotalLines, blnCancel)
        If blnCancel = True Then Exit For
        
        If Len(Trim$(strLine(i))) > 0 Then
            Set objRequest = AgentChar.Speak(strLine(i))
        
            Do While objRequest.Status <> 0
                DoEvents
            Loop
        End If
    Next
    
    AgentChar.StopAll
    If blnWasVisible = False Then AgentChar.Hide mblnAlwaysFast
End Sub


'***********************************************
'Clear all loaded commands
'***********************************************
Public Sub RemoveAllCommands()
    AgentChar.Commands.RemoveAll
End Sub

Private Sub MSAgent_ListenComplete(ByVal CharacterID As String, ByVal Cause As Integer)
    mintListen = False
End Sub


