VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsTasks"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'---private objects and events
Private mo_DataService As clsDataService '---data for the object
Private mo_PickList As clsPickList '---pick list needed for forms
Private WithEvents mf_Tasks As frmTasks '---all the tasks on frmTasks
Attribute mf_Tasks.VB_VarHelpID = -1
Private WithEvents mf_Task As frmTask '---an individual task on frmTask
Attribute mf_Task.VB_VarHelpID = -1
Private mo_DataGrid As DataGrid
Private WithEvents mo_DataProvider As clsDataProvider '---host data
Attribute mo_DataProvider.VB_VarHelpID = -1
Private ml_CurTaskID As Long '---currently selected task ID
Private ms_Project As String '---used when working from frmProject
Private mo_ProgConfig As clsProgConfig
Private ms_TaskFilter As String
Private mo_Task As clsTask
Private mb_NeedRefresh As Boolean
Private ms_Resource As String
Private ms_Source As String
'---public objects and events
Public Event TaskUpdated()
Public Sub DeleteTask()
   
   If MsgBox("Confirm deletion of this task", vbQuestion + vbYesNo) = vbYes Then
      mo_DataService.ArchiveTask mo_DataProvider
      mo_DataProvider.Delete
   End If
   
End Sub



Public Sub DisplayProjectTasks(sProjName As String)

   ms_Project = sProjName
   Set mo_DataProvider = New clsDataProvider
   mo_DataProvider.Init mo_DataService, DP_TASKS, sProjName
   With mo_DataGrid
      Set .DataSource = mo_DataProvider
      .DataMember = mo_DataProvider.DataMemberName
      .ReBind
      mo_DataProvider.MoveFirst
   End With

End Sub

Public Sub DisplaySourceTasks(sSource As String)

   ms_Source = sSource
   Set mo_DataProvider = New clsDataProvider
   mo_DataProvider.Init mo_DataService, DP_SOURCE_TASKS, sSource
   With mo_DataGrid
      Set .DataSource = mo_DataProvider
      .DataMember = mo_DataProvider.DataMemberName
      .ReBind
      mo_DataProvider.MoveFirst
   End With

End Sub

Public Sub FilterTaskStatus(sCritera As String)
   
   ms_TaskFilter = sCritera
   mo_DataProvider.Filter ms_TaskFilter

End Sub



Public Sub RefreshProvider()

   mo_DataProvider.Requery

End Sub

Public Sub ShowResourcesTasks(sAssigned As String, sProj As String)

      mo_DataProvider.Filter "Assigned = " & Chr$(39) & sAssigned & Chr$(39) & " And Project <> " & Chr$(39) & sProj & Chr$(39) & " And Status <> " & Chr$(39) & "Terminated" & Chr$(39)
      mo_DataProvider.Sort "Complete"

End Sub

Public Sub LoadTaskGrid()
   
   Set mo_DataProvider = New clsDataProvider
   mo_DataProvider.Init mo_DataService, DP_TASKS
   With mo_DataGrid
      Set .DataSource = mo_DataProvider
      .DataMember = mo_DataProvider.DataMemberName
      .ReBind
      mo_DataProvider.MoveFirst
   End With
   
End Sub


Public Sub ModifyTask(tMode As TASK_MODE, Optional lProjID As Long = 0)
   
   '---load task form
   Set mf_Task = New frmTask
   Load mf_Task
   mo_Task.InitTaskForm mf_Task, mo_PickList, mo_DataService
   '---configure task form
   If tMode = TASK_EDIT Then
      mo_Task.LoadTaskForm mf_Task, mo_DataProvider
      SetCombo mf_Task.cboProject, lProjID
   Else
      mf_Task.Created = Format(Now, "mm/dd/yyyy")
      If lProjID <> 0 Then
         SetCombo mf_Task.cboProject, lProjID
      Else
         mf_Task.cboProject.ListIndex = 0
      End If
      '---preset resource if working from individual task display
      If ms_Resource <> "" Then SetCombo mf_Task.cboResource, ms_Resource
   End If
   '---set mode on task form
   mf_Task.Mode = tMode
   '---show form and restrict user action
   mf_Task.Show vbModal
   If Not (mf_Task Is Nothing) Then
      Unload mf_Task
      Set mf_Task = Nothing
   End If

End Sub



Public Sub Refresh()
   
   mb_NeedRefresh = True

End Sub

Public Sub Show(Optional sResource As String = "")

   If (mf_Tasks Is Nothing) Then
      SetHourglass
      Set mf_Tasks = New frmTasks
      Load mf_Tasks
      Set mo_DataGrid = mf_Tasks.grdTasks
      '---load tasks
      LoadTaskGrid
      '---Load resouce combo
      mo_PickList.LoadPickList mf_Tasks.cboResource, PIC_RESOURCE
      '---configure task list
      ms_Resource = sResource
      mf_Tasks.Configure ms_Resource
      If sResource <> "" Then '---set data provider for individual task display
         ms_TaskFilter = "Assigned =" & Chr$(39) & sResource & Chr$(39)
         mo_DataProvider.Filter ms_TaskFilter
         mo_DataProvider.Sort "Status, Complete"
      End If
      SetReady
   End If
   
   With mf_Tasks
      .WindowState = 0
      .Show
      .ZOrder 0
   End With

End Sub
Public Sub Init(oDataService As clsDataService, oProgConfig As clsProgConfig, oPickList As clsPickList, Optional grd As DataGrid)

   '---set module objects
   Set mo_DataService = oDataService
   Set mo_ProgConfig = oProgConfig
   Set mo_Task = New clsTask
   Set mo_PickList = oPickList
   Set mo_DataGrid = grd

End Sub


Public Sub SortTaskGrid(sCriteria As String)

   mo_DataProvider.Sort sCriteria

End Sub


Public Property Get TaskData() As ADODB.Recordset
   
   Set TaskData = mo_DataProvider.PrimaryRecordSet

End Property

Public Sub TerminateTask()
   
   If Not mo_DataProvider.PrimaryRecordSet.EOF Then
      With mo_DataProvider
         .PrimaryRecordSet.Fields("Status").Value = "Terminated"
         .Update
         .Requery
      End With
   End If


End Sub

Private Sub Class_Terminate()

   On Error Resume Next
   Set mo_DataService = Nothing
   Set mo_PickList = Nothing
   Set mf_Tasks = Nothing
   Set mo_DataGrid = Nothing
   Set mo_DataProvider = Nothing
   Set mo_ProgConfig = Nothing
   
   Debug.Print "clsTasks terminating..."

End Sub


Private Sub mf_Task_Report(lRecID As Long, tRptMode As RPT_MODE, tExpType As EXP_TYPE)
   
   Dim oReport As clsReports
   Dim sRptName As String
   Dim oRS As New ADODB.Recordset
   Dim sAssigned As String
   
   Set oReport = New clsReports
   Set oRS = mo_DataProvider.PrimaryRecordSet.Clone
   oRS.Filter = "ID =" & lRecID
   sAssigned = oRS.Fields("Assigned").Value
   sRptName = oRS.Fields("Project").Value & " Task Detail (" & CStr(lRecID) & ") for " & sAssigned
   oReport.DoReport oRS, RPT_TASK, tRptMode, sRptName, , tExpType, sAssigned
   oRS.Close
   Set oRS = Nothing

End Sub

Private Sub mf_Task_Save()
   
   mo_Task.SaveTask mo_DataProvider, mf_Task, mo_DataGrid
   
End Sub




Private Sub mf_Tasks_Activate()

   Dim sCap As String
   
   If mb_NeedRefresh Then
      mb_NeedRefresh = False
      SetHourglass
      sCap = mf_Tasks.Caption
      mf_Tasks.Caption = sCap & " (refreshing tasks...)"
      mo_DataProvider.Requery
      Set mo_PickList = Nothing
      Set mo_PickList = New clsPickList
      mo_PickList.Init mo_DataService
      mf_Tasks.Caption = sCap
      SetReady
   End If
      


End Sub




Private Sub mf_Tasks_AssgnReport(tRptSubType As RPT_SUBTYPE, tRptMode As RPT_MODE, tExpType As EXP_TYPE, sResource As String, bTerminated As Boolean)

   Dim oReport As New clsReports
   Dim sRptName As String
   Dim oDP As New clsDataProvider
   
   '---create data
   Select Case tRptSubType
      Case RPT_BYPROJ
         sRptName = "Proj Asgn for " & sResource
         If bTerminated Then
            oDP.Init mo_DataService, DP_ASSIGN_PROJECTS_TERM, sResource
         Else
            oDP.Init mo_DataService, DP_ASSIGN_PROJECTS, sResource
         End If
      Case RPT_BY_COMPLETE
         sRptName = "Deliverables for " & sResource
         If bTerminated Then
            oDP.Init mo_DataService, DP_ASSIGN_COMPLETE_TERM, sResource
         Else
            oDP.Init mo_DataService, DP_ASSIGN_COMPLETE, sResource
         End If
   End Select
   Call oReport.DoReport(oDP.PrimaryRecordSet, RPT_ASSIGNMENTS, tRptMode, sRptName, tRptSubType, tExpType, sResource)
   Set oDP = Nothing
   Set oReport = Nothing
   
End Sub


Private Sub mf_Tasks_MasterReport(tRptMode As RPT_MODE, tRptType As RPT_TYPE)

   Dim oReport As New clsReports
   Call oReport.DoReport(mo_DataProvider.PrimaryRecordSet, tRptType, tRptMode)
   
End Sub


Private Sub mf_Tasks_ResourceLoaded(sCriteria As String)
   
   On Error Resume Next '---will fail on first load as cboResource is set
   
   If sCriteria = "" Then
      ms_TaskFilter = sCriteria
      LoadTaskGrid
   Else
      ms_TaskFilter = "Assigned =" & Chr$(39) & sCriteria & Chr$(39)
      mo_DataProvider.Filter ms_TaskFilter
   End If
End Sub



Private Sub mf_Tasks_SortGrid(sCritera As String)

   mo_DataProvider.Sort sCritera

End Sub


Private Sub mf_Tasks_TerminateTask()

   Call TerminateTask

End Sub

Private Sub mf_Tasks_Unloaded()
   
   Set mo_DataGrid = Nothing
   Set mf_Tasks = Nothing
   If ms_Resource <> "" Then go_Application.RemoveTaskMember ms_Resource
   
End Sub

Private Sub mo_DataProvider_DataUpdated()
       
   '---here we have undesirable coupling since we are calling the application task _
   as a global object.  Need to do better here.  It is because in the case when ms_Resource <> "" _
   that this object is part of a collection in clsApplication and you can't raise events as one of _
   the members of the collection.
      
   RaiseEvent TaskUpdated
   If ms_Resource <> "" Then go_Application.UpdateProgram UPD_ASSIGNED
   If ms_Project <> "" Then go_Application.UpdateProgram UPD_PROJECT_TASK
   If ms_Source <> "" Then go_Application.UpdateProgram UPD_ASSIGNED_OR_PROJECT
   
End Sub

Private Sub mo_DataProvider_MoveComplete(lKey As Long)
   
   '---set current key
   On Error Resume Next
   ml_CurTaskID = lKey
   
End Sub
Private Sub mf_Tasks_Modify(tMode As TASK_MODE)
   
   '---this is one way this object enables modification when it is _
   working in the Task mode (from frmTasks) The calls here to ModifyTask and _
   DeleteTask are used when working in the project mode (frmProject)
   Select Case tMode
      Case TASK_ADD, TASK_EDIT
         Call ModifyTask(tMode)
      Case TASK_DEL
         Call DeleteTask
      Case TASK_ARCHIVE
         If MsgBox("Please confirm archiving of all terminated tasks.", vbQuestion + vbYesNo) = vbYes Then
               mo_DataService.ArchiveTasks ms_Resource
         End If
         mo_DataProvider.Requery
         RaiseEvent TaskUpdated
   End Select

End Sub

