VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsToday"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'---private module objects
Private WithEvents mf_Appt As frmAppointment
Attribute mf_Appt.VB_VarHelpID = -1
Private WithEvents mf_Today As frmToday
Attribute mf_Today.VB_VarHelpID = -1
Private WithEvents mo_DPApts As clsDataProvider '---host apt data
Attribute mo_DPApts.VB_VarHelpID = -1
Private WithEvents mo_DP_Mng_Tasks As clsDataProvider '---host manager's task data
Attribute mo_DP_Mng_Tasks.VB_VarHelpID = -1
Private WithEvents mo_DP_Asg_Tasks As clsDataProvider '---host assigned task data
Attribute mo_DP_Asg_Tasks.VB_VarHelpID = -1
Private WithEvents mf_Task As frmTask
Attribute mf_Task.VB_VarHelpID = -1
Private mo_Task As clsTask
Private mo_PickList As clsPickList
Private mo_ProgConfig As clsProgConfig
Private mo_DataService As clsDataService '---gets data
Private ms_CurApt As String
Private ml_AppID As Long
Private ms_CurMngTask As String
Private ms_CurAsgTask As String
Private ml_MngTaskID As Long
Private ml_AsgTaskID As Long
'---save filters for resetting
Private ms_MngFilter As String
Private ms_AsgFilter As String
Private ms_AptFilter As String
Private mt_EditGrid As GRID_TYPE
Private mb_NeedRefresh As Boolean
'---public objects and variables
Public Event TaskUpdated()



Public Property Get ApptDP() As clsDataProvider

   Set ApptDP = mo_DPApts

End Property

Public Property Get MngTasks() As clsDataProvider

   Set MngTasks = mo_DP_Mng_Tasks

End Property


Public Sub Refresh()
   
   mb_NeedRefresh = True

End Sub

Public Sub Init(oDataService As clsDataService, oProgConfig As clsProgConfig, oPickList As clsPickList)

   '---init module objects
   Set mo_DataService = oDataService
   Set mo_ProgConfig = oProgConfig
   Set mo_PickList = oPickList
   Set mo_Task = New clsTask
   
End Sub


Private Sub LoadTaskGrid(oDP As clsDataProvider, grdTasks As DataGrid, eResource As DP_RECSOURCE)
   
   oDP.Init mo_DataService, eResource
   With grdTasks
      Set .DataSource = oDP
      .DataMember = oDP.DataMemberName
      .ReBind
      oDP.MoveFirst
   End With

End Sub



Private Sub ModifyTask(tMode As TASK_MODE, oDP As clsDataProvider, Optional bManager As Boolean = False)

   '---load task form
   Set mf_Task = New frmTask
   Load mf_Task
   mo_Task.InitTaskForm mf_Task, mo_PickList, mo_DataService
   '---configure task form
   If tMode = TASK_EDIT Then
      mo_Task.LoadTaskForm mf_Task, oDP
   Else
      mf_Task.Created = Format(Now, "mm/dd/yyyy")
      If mf_Task.cboProject.ListCount > 0 Then mf_Task.cboProject.ListIndex = 0
      If bManager Then '---set the inital display on assigned to be the manager
         SetCombo mf_Task.cboResource, mo_ProgConfig.GetManager
      Else '---set it not to be the manager (see clsPickList.LoadPickList  where ItemData = Authority from Resources)
         SetCombo mf_Task.cboResource, 1 '---only the manager has Authority = 0 so this sets the next guy in the list
      End If
   End If
   '---set mode on task form
   mf_Task.Mode = tMode
   '---show form and restrict user action
   mf_Task.Show vbModal
   Unload mf_Task
   Set mf_Task = Nothing

End Sub


Public Sub Show()

   '---check for existence of form
   If (mf_Today Is Nothing) Then
      SetHourglass
      '---load the form
      Set mf_Today = New frmToday
      Load mf_Today
      '---load appointment grid
      Set mo_DPApts = New clsDataProvider
      mo_DPApts.Init mo_DataService, DP_APPOINTMENTS
      With mf_Today.grdAppointments
         Set .DataSource = mo_DPApts
         .DataMember = mo_DPApts.DataMemberName
         .ReBind
         mo_DPApts.MoveFirst
      End With
      '---filter appointments for today
      mf_Today_AptFiltered APT_TDY, APT_CAT_ALL
      '---create mng task data
      Set mo_DP_Mng_Tasks = New clsDataProvider
      LoadTaskGrid mo_DP_Mng_Tasks, mf_Today.grdMngTasks, DP_MGR_TASKS
      '---set for today
      mf_Today_FilterTasks TDY_MNG, TTFV_TDY_PAST
      '---create asg task data
      Set mo_DP_Asg_Tasks = New clsDataProvider
      LoadTaskGrid mo_DP_Asg_Tasks, mf_Today.grdAsgTasks, DP_MGR_ASG_TASKS
      '---set for today
      mf_Today_FilterTasks TDY_ASG, TTFV_TDY_PAST
      SetReady
   End If
   
   With mf_Today
       .WindowState = 0
      .Show
      .ZOrder 0
   End With

End Sub

Private Sub mf_Appt_Report()
   
   Dim oReport As clsReports
   Dim oRS As New ADODB.Recordset

   Set oReport = New clsReports
   Set oRS = mo_DPApts.PrimaryRecordSet.Clone
   '---filter data provider
   oRS.Filter = "ID = " & mf_Appt.ID
   '---run report
   oReport.DoReport oRS, RPT_APT, RPT_PRINT
   oRS.Close
   Set oRS = Nothing
   
End Sub

Private Sub mf_Appt_Save()

   With mo_DPApts
      If mf_Appt.Mode = APT_ADD Then .AddNew
      .PrimaryRecordSet.Fields("Appointment").Value = mf_Appt.Apt
      .PrimaryRecordSet.Fields("AptDate").Value = mf_Appt.AptDate
      .PrimaryRecordSet.Fields("AptTime").Value = IIf(mf_Appt.AptTime = "", Null, mf_Appt.AptTime)
      .PrimaryRecordSet.Fields("Notes").Value = mf_Appt.Notes
      .PrimaryRecordSet.Fields("Category").Value = mf_Appt.cboCategory.ItemData(mf_Appt.cboCategory.ListIndex)
      .Update
      If mf_Appt.Mode = APT_ADD Then
         .MoveLast
         mf_Appt.ID = .PrimaryRecordSet.Fields("ID").Value
      End If
   End With
   '---enable reporting
   mf_Appt.cmdAction(2).Enabled = True
   '---reset mode
   mf_Appt.Mode = APT_EDIT
   '---update grid
   mo_DPApts.Requery
   mf_Today.grdAppointments.ReBind
   
End Sub


Private Sub mf_Task_Report(lRecID As Long, tRptMode As RPT_MODE, tExpType As EXP_TYPE)
   
   Dim oReport As clsReports
   Dim sRptName As String
   Dim sAssigned As String
   
   Dim oRS As New ADODB.Recordset
   
   Set oReport = New clsReports
   If mt_EditGrid = EDIT_MNG Then
      Set oRS = mo_DP_Mng_Tasks.PrimaryRecordSet.Clone
      oRS.Filter = "ID =" & lRecID
      sAssigned = mo_DP_Mng_Tasks.PrimaryRecordSet.Fields("Assigned").Value
      sRptName = mo_DP_Mng_Tasks.PrimaryRecordSet.Fields("Project").Value & " Task Detail (" & CStr(lRecID) & ") for " & sAssigned
      oReport.DoReport oRS, RPT_TASK, tRptMode, sRptName, , tExpType, sAssigned
   Else
      Set oRS = mo_DP_Asg_Tasks.PrimaryRecordSet.Clone
      oRS.Filter = "ID =" & lRecID
      sAssigned = mo_DP_Asg_Tasks.PrimaryRecordSet.Fields("Assigned").Value
      sRptName = mo_DP_Asg_Tasks.PrimaryRecordSet.Fields("Project").Value & " Task Detail (" & CStr(lRecID) & ") for " & sAssigned
      oReport.DoReport oRS, RPT_TASK, tRptMode, sRptName, , tExpType, sAssigned
   End If
   oRS.Close
   Set oRS = Nothing
   
End Sub

Private Sub mf_Task_Save()
   
   '---fired from frmTask when task is saved
   If mt_EditGrid = EDIT_MNG Then
      mo_Task.SaveTask mo_DP_Mng_Tasks, mf_Task, mf_Today.grdMngTasks
      mo_DP_Asg_Tasks.Requery
   Else
      mo_Task.SaveTask mo_DP_Asg_Tasks, mf_Task, mf_Today.grdAsgTasks
      mo_DP_Mng_Tasks.Requery
   End If
   
End Sub



Private Sub mf_Today_Activate()
   
   Dim sCap As String
   
   If mb_NeedRefresh Then
      SetHourglass
      sCap = mf_Today.Caption
      mf_Today.Caption = sCap & " (refreshing task lists...)"
      mb_NeedRefresh = False
      '---refresh both grids
      mo_DP_Mng_Tasks.Requery
      mo_DP_Asg_Tasks.Requery
      '---refresh picklist
      Set mo_PickList = Nothing
      Set mo_PickList = New clsPickList
      mo_PickList.Init mo_DataService
      '---restore caption
      mf_Today.Caption = sCap
      SetReady
   End If


End Sub

Private Sub mf_Today_AptFiltered(tAptMode As APT_FILTER, tAptCat As APT_CAT)
   
   Dim dEnd As Date
   
   On Error GoTo TRAP
   
   '---create the time filter
   Select Case tAptMode
      Case APT_TDY
         ms_AptFilter = "AptDate = " & "#" & Format(Now, "mm/dd/yy") & "#"
      Case APT_ALL
         ms_AptFilter = "AptDate > " & "#" & "01/01/01" & "#"
      Case APT_WEEK
         dEnd = DateAdd("ww", 1, Now)
         ms_AptFilter = "AptDate <= " & "#" & dEnd & "#"
      Case APT_SELECTED
         ms_AptFilter = "AptDate = " & "#" & mf_Today.SelectedDate & "#"
   End Select
   
   '---create the cat filter
   If tAptCat = APT_CAT_ALL Then
      ms_AptFilter = ms_AptFilter
   Else
      ms_AptFilter = ms_AptFilter & " And Category = " & tAptCat
   End If
   '---filter the recordset
   mo_DPApts.Filter ""
   mo_DPApts.Filter ms_AptFilter
   mo_DPApts.Sort "AptDate"
   
   Exit Sub
   
TRAP:
   MsgBox "Error in filtering appointments: " & Err.Description, vbCritical
   Resume Next
   
End Sub





Private Sub mf_Today_FilterTasks(tType As TDY_TASK_TYPE, tValue As TDY_TASK_FILTER_VALUE)

   Dim sFilterValue As String
   Dim dTimeSpan As Date
   
   '---determine filter value
   Select Case tValue
      Case Is = 0, Is = 7 '---today and past due
         If tType = TDY_MNG Then
            sFilterValue = "Complete <= " & "#" & Format(Now, "mm/dd/yy") & "#" & " And Assigned = " & Chr$(39) & mo_ProgConfig.GetManager & Chr$(39)
         Else
            sFilterValue = "Complete <= " & "#" & Format(Now, "mm/dd/yy") & "#" & " And Assigned <> " & Chr$(39) & mo_ProgConfig.GetManager & Chr$(39)
         End If
      Case Is = 1, Is = 2, Is = 3, Is = 4, Is = 5, Is = 8, Is = 9, Is = 10, Is = 11, Is = 12
         If tValue <= 5 Then
            dTimeSpan = DateAdd("d", tValue, Now)
         Else '---map numbers to approriate increments
            dTimeSpan = DateAdd("d", tValue - 7, Now)
         End If
         If tType = TDY_MNG Then
            sFilterValue = "Complete <= " & "#" & dTimeSpan & "#" & " And Assigned = " & Chr$(39) & mo_ProgConfig.GetManager & Chr$(39)
         Else
            sFilterValue = "Complete <= " & "#" & dTimeSpan & "#" & " And Assigned <> " & Chr$(39) & mo_ProgConfig.GetManager & Chr$(39)
         End If
      Case Is = 6, Is = 13 '---all tasks
         If tType = TDY_MNG Then
            sFilterValue = "Assigned = " & Chr$(39) & mo_ProgConfig.GetManager & Chr$(39)
         Else
            sFilterValue = "Assigned <> " & Chr$(39) & mo_ProgConfig.GetManager & Chr$(39)
         End If
   End Select
   
   '---set filter value
   If tType = TDY_MNG Then
      ms_MngFilter = sFilterValue
      mo_DP_Mng_Tasks.Filter ms_MngFilter
   Else '---assigned filter
      ms_AsgFilter = sFilterValue
      mo_DP_Asg_Tasks.Filter ms_AsgFilter
   End If
   
   

End Sub

Private Sub mf_Today_ModifyAppointment(tMode As APT_MODE)
   
   Select Case tMode
      Case APT_ADD, APT_EDIT
         '---in case user double clicks on an empty apt grid
         If mo_DPApts.PrimaryRecordSet.RecordCount = 0 Then tMode = APT_ADD
         '---call modify
         Set mf_Appt = New frmAppointment
         Load mf_Appt
         mf_Appt.Mode = tMode
         mo_PickList.LoadPickList mf_Appt.cboCategory, PIC_CATEGORY
         If tMode = APT_ADD Then
            mf_Appt.AptDate = mf_Today.AddAptDate
            mf_Appt.cmdAction(2).Enabled = False
         Else
            mf_Appt.ID = mo_DPApts.PrimaryRecordSet.Fields("ID").Value
            mf_Appt.AptDate = mo_DPApts.PrimaryRecordSet.Fields("AptDate").Value
            mf_Appt.Apt = mo_DPApts.PrimaryRecordSet.Fields("Appointment").Value
            mf_Appt.AptTime = mo_DPApts.PrimaryRecordSet.Fields("AptTime").Value
            mf_Appt.Notes = mo_DPApts.PrimaryRecordSet.Fields("Notes").Value
            mf_Appt.Category = mo_DPApts.PrimaryRecordSet.Fields("Category").Value
         End If
         mf_Appt.Show vbModal
         Unload mf_Appt
         Set mf_Appt = Nothing
         '---refilter
         mo_DPApts.Filter ms_AptFilter
         '---reset grid
         mf_Today.grdAppointments.ReBind
      Case APT_DEL
         If MsgBox("Confirm Appointment Deletion for " & ms_CurApt, vbQuestion + vbYesNo) = vbYes Then
            mo_DPApts.Delete
            'mf_Today.grdAppointments.ReBind
         End If
   End Select

End Sub




Private Sub mf_Today_ModifyTask(tType As TDY_TASK_TYPE, tMode As TASK_MODE)

   If tType = TDY_MNG Then
      mt_EditGrid = EDIT_MNG
      Select Case tMode
         Case TASK_EDIT
            If Not mo_DP_Mng_Tasks.PrimaryRecordSet.EOF Then Call ModifyTask(tMode, mo_DP_Mng_Tasks, True)
         Case TASK_ADD
            Call ModifyTask(tMode, mo_DP_Mng_Tasks, True)
         Case TASK_DEL
            If Not mo_DP_Mng_Tasks.PrimaryRecordSet.EOF Then
               If MsgBox("Confirm deletion of task: " & ms_CurMngTask, vbQuestion + vbYesNo) = vbYes Then
                  mo_DataService.ArchiveTask mo_DP_Mng_Tasks
                  mo_DP_Mng_Tasks.Delete
               End If
            End If
      End Select
   Else
      mt_EditGrid = EDIT_ASG
      Select Case tMode
         Case TASK_EDIT
            If Not mo_DP_Asg_Tasks.PrimaryRecordSet.EOF Then Call ModifyTask(tMode, mo_DP_Asg_Tasks)
         Case TASK_ADD
            Call ModifyTask(tMode, mo_DP_Asg_Tasks)
         Case TASK_DEL
            If Not mo_DP_Asg_Tasks.PrimaryRecordSet.EOF Then
               If MsgBox("Confirm deletion of task: " & ms_CurAsgTask, vbQuestion + vbYesNo) = vbYes Then
                  mo_DataService.ArchiveTask mo_DP_Asg_Tasks
                  mo_DP_Asg_Tasks.Delete
               End If
            End If
      End Select
   End If

End Sub

Private Sub mf_Today_PopUpMenu(ePopMode As POP_MODE, eGridType As GRID_TYPE)

   Select Case ePopMode
      Case POP_TERMINATE
         If eGridType = EDIT_MNG Then
            If Not mo_DP_Mng_Tasks.PrimaryRecordSet.EOF Then
               mo_DP_Mng_Tasks.PrimaryRecordSet.Fields("Status").Value = "Terminated"
               mo_DP_Mng_Tasks.Update
               mo_DP_Mng_Tasks.Requery
            End If
         Else
            If Not mo_DP_Asg_Tasks.PrimaryRecordSet.EOF Then
               mo_DP_Asg_Tasks.PrimaryRecordSet.Fields("Status").Value = "Terminated"
               mo_DP_Asg_Tasks.Update
               mo_DP_Asg_Tasks.Requery
            End If
         End If
      Case Else
         MsgBox "Do code for popups"
   End Select

End Sub

Private Sub mf_Today_Report(tRptType As RPT_TYPE)
   
   Dim oReport As clsReports
   
   Set oReport = New clsReports
   Select Case tRptType
      Case RPT_TODAY
         oReport.DoReport mo_DP_Mng_Tasks.PrimaryRecordSet, tRptType, RPT_PRINT
      Case RPT_TODAY_ASG
         oReport.DoReport mo_DP_Asg_Tasks.PrimaryRecordSet, tRptType, RPT_PRINT
      Case RPT_APT_SUM
         oReport.DoReport mo_DPApts.PrimaryRecordSet, tRptType, RPT_PRINT
   End Select
   
End Sub




Private Sub mf_Today_SortGrid(eType As TDY_TASK_TYPE, sCritera As String)

   If eType = TDY_MNG Then
      mo_DP_Mng_Tasks.Sort sCritera
   Else
      mo_DP_Asg_Tasks.Sort sCritera
   End If

End Sub

Private Sub mf_Today_Unloaded()

   Set mf_Today = Nothing

End Sub


Private Sub mo_DP_Asg_Tasks_DataUpdated()

   RaiseEvent TaskUpdated

End Sub

Private Sub mo_DP_Asg_Tasks_MoveComplete(lKey As Long)
   
   If lKey <> 0 Then
      ml_AsgTaskID = lKey
      ms_CurAsgTask = mo_DP_Asg_Tasks.PrimaryRecordSet.Fields("Description").Value
   End If

End Sub

Private Sub mo_DP_Mng_Tasks_DataUpdated()

   RaiseEvent TaskUpdated

End Sub

Private Sub mo_DPApts_MoveComplete(lKey As Long)

   ml_AppID = lKey
   If lKey <> 0 Then
      If Not mo_DPApts.PrimaryRecordSet.EOF Then ms_CurApt = mo_DPApts.PrimaryRecordSet.Fields("Appointment").Value
   End If
   
End Sub


Private Sub mo_DP_Mng_Tasks_MoveComplete(lKey As Long)
   
   If lKey <> 0 Then
      ml_MngTaskID = lKey
      ms_CurMngTask = mo_DP_Mng_Tasks.PrimaryRecordSet.Fields("Description").Value
   End If

End Sub


