VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsTask"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit



Public Sub InitTaskForm(fTask As Form, oPickList As clsPickList, oDataService As clsDataService)

   '---load task form pick lists
   oPickList.LoadPickList fTask.cboResource, PIC_RESOURCE
   oPickList.LoadPickList fTask.cboPriority, PIC_PRIORITY
   oPickList.LoadPickList fTask.cboSource, PIC_SOURCE
   oPickList.LoadPickList fTask.cboStatus, PIC_STATUS
   '---load project list
   oDataService.LoadProjects fTask.cboProject

End Sub

Public Sub LoadTaskForm(fTask As Form, oDP As clsDataProvider)

   
   With oDP
      fTask.ID = .PrimaryRecordSet.Fields("ID").Value
      fTask.Description = .PrimaryRecordSet.Fields("Description").Value
      fTask.Assigned = .PrimaryRecordSet.Fields("Assigned").Value
      fTask.Start = .PrimaryRecordSet.Fields("Start").Value
      fTask.Complete = .PrimaryRecordSet.Fields("Complete").Value
      fTask.Status = .PrimaryRecordSet.Fields("Status").Value
      fTask.Priority = .PrimaryRecordSet.Fields("Priority").Value
      fTask.Source = .PrimaryRecordSet.Fields("Source").Value
      fTask.Notes = .PrimaryRecordSet.Fields("Notes").Value
      fTask.Created = IIf(IsNull(.PrimaryRecordSet.Fields("Created").Value), Format(Now, "mm/dd/yyyy"), .PrimaryRecordSet.Fields("Created").Value)
      fTask.Project = .PrimaryRecordSet.Fields("Project").Value
      fTask.Scope = .PrimaryRecordSet.Fields("Scope").Value & ""
   End With

End Sub

Public Sub SaveTask(oDP As clsDataProvider, fTask As Form, grdTask As DataGrid)
   
   SetHourglass
   With oDP
      If fTask.Mode = TASK_ADD Then
         .AddNew
         SetRecordsetValues oDP, fTask
         '---obtain new task ID for task just saved
         .MoveLast
         fTask.ID = .PrimaryRecordSet.Fields("ID").Value
         '---change mode of task form
         fTask.Mode = TASK_EDIT
      Else
         '---position record set
         .FindRecord "ID =" & fTask.ID
         SetRecordsetValues oDP, fTask
      End If
   End With
   UpdateGrid oDP, grdTask
   SetReady

End Sub

Public Sub SetRecordsetValues(oDP As clsDataProvider, fTask As Form)

   On Error GoTo TRAP
   
   With oDP
      .PrimaryRecordSet.Fields("Description").Value = fTask.Description
      .PrimaryRecordSet.Fields("Project").Value = fTask.Project
      .PrimaryRecordSet.Fields("Assigned").Value = fTask.Assigned
      .PrimaryRecordSet.Fields("Start").Value = fTask.Start
      .PrimaryRecordSet.Fields("Complete").Value = fTask.Complete
      .PrimaryRecordSet.Fields("Status").Value = fTask.Status
      .PrimaryRecordSet.Fields("Priority").Value = fTask.Priority
      .PrimaryRecordSet.Fields("Source").Value = fTask.Source
      .PrimaryRecordSet.Fields("Notes").Value = fTask.Notes
      .PrimaryRecordSet.Fields("Created").Value = fTask.Created
      .PrimaryRecordSet.Fields("Scope").Value = fTask.Scope
      .Update
   End With
   
   Exit Sub
   
TRAP:
   Select Case Err.Number
      Case -2147217887 '--Multiple-step operation generated errors. Check each status value.
         Resume Next
      Case Else
         MsgBox Err.Description
   End Select
   Exit Sub
    
End Sub

Public Sub UpdateGrid(oDP As clsDataProvider, grdTasks As DataGrid)

   '---refresh the data provider
   oDP.Requery
   '---refresh task list based on which one this object is working with
   grdTasks.ReBind

End Sub

